
      SUBROUTINE PLTEFF(EAR, IGROUP, ICHANB, ICHANE, RESPON, effar, 
     &                  Y, IERY, NPTS, NVEC, CMD, NCMD, ixopt)

      INCLUDE '../../inc/xspec.inc'

      INTEGER IERY(*), NPTS, NVEC, NCMD, ixopt
      REAL EAR(0:*), RESPON(*), effar(*)
      REAL Y(*)
      INTEGER IGROUP(*), ICHANB(*), ICHANE(*)
      CHARACTER CMD(*)*(*)

C---
C XSPEC plotting subroutine to indicate the efficiencies of the
C response matrix using PGPLOT software
C---
C arguments
C EAR       I    Array of energy bin boundarys
C IGROUP    I    Number of pha bin ranges for the ith
C			energy range.
C ICHANB    I    First pha bin for the ith pha bin range
C ICHANE    I    Last   "   "   "   "   "   "   "    "
C RESPON    I    Response matrix
C EFFAR     I    Effective areas
C Y         I/O  Scratch array used by PLT.
C IERY      I/O  Used by PLT.
C CMD       I/O  Command array used by PLT.
C IXOPT     I    If 1 or 2 then plot vs energy, if 3 vs wavelength
C---
C 8 Jan 1984 - rashafer
C 1.0:	Will give the efficiency for all the data (this
C	means that with multiple files the efficiency can be greater
C	than one)
C 1.1:	plot maximum set to 2.* maximum efficiency value, plot covers
C	3 orders of magnitude in eff area
C 1.2:  plot different data groups separately
C---
      REAL NO, KEVTOA
      PARAMETER (NO=-1.2E-34, KEVTOA = 12.398419)

      REAL ymin
      INTEGER ie, ng, ir, jg, i, idset, ies, iee, iy

      INTEGER dgndst, rgnenr, rgbear, rgdtse
      EXTERNAL dgndst, rgnenr, rgbear, rgdtse

c Turn skip on to separate the datagroups

      cmd(ncmd+1) = 'SKIP ON'
      ncmd = ncmd + 1

      ng = 0
      ir = 0
      ies = 0
      ymin = 1.e32

c  Calculate the total number of X-axis points in the plot

      NPTS = 0
      DO idset = 1, dgndst()-1
         NPTS = NPTS + rgnenr(idset) + 1
      ENDDO
      NPTS = NPTS + rgnenr(dgndst())

c  Loop round the datasets

      DO idset = 1, dgndst()

         IF ( rgnenr(idset) .LE. 0 ) GOTO 100

c  Set the X-axis array

         IF ( ixopt.EQ.1 .OR. ixopt.EQ.2 )THEN
            DO ie = 1, rgnenr(idset)
               iy = ies + ie
               iee = rgbear(idset) + ie
               Y(iy) = (EAR(iee)+EAR(iee-1))/2.
               Y(iy+NPTS) = (EAR(iee)-EAR(iee-1))/2.
            ENDDO
         ELSEIF( ixopt.EQ.3 )THEN
            DO ie = 1, rgnenr(idset)
               iy = ies + ie
               iee = rgbear(idset) + ie
               IF ( ear(iee-1) .LE. 0. .OR. ear(iee) .LE. 0. ) THEN
                  y(iy) = NO
                  y(iy+NPTS) = NO
               ELSE
                  Y(iy) = ((KEVTOA/EAR(iee))+(KEVTOA/EAR(iee-1)))/2.
                  Y(iy+NPTS) =((KEVTOA/EAR(iee))-(KEVTOA/EAR(iee-1)))/2.
               ENDIF
            ENDDO
         ENDIF

c  Loop through the response accumulating in the
c  appropriate arrays.

         DO ie = 1, rgnenr(idset)
            iy = ies + ie
            iee = rgdtse(idset) + ie
            y(iy+2*NPTS) = 0.
            IF (igroup(iee).GT.0) THEN
               DO jg = 1, igroup(iee)
                  ng = ng + 1
                  DO i = ichanb(ng), ichane(ng)
                     ir = ir + 1
                     Y(iy+2*NPTS) = Y(iy+2*NPTS) + respon(ir)
                  ENDDO
               ENDDO
               IF(Y(iy+2*NPTS) .LE. 0) THEN
                  Y(iy+2*NPTS) = 0.
               ELSE
                  Y(iy+2*NPTS) = Y(iy+2*NPTS) * effar(iee)
                  ymin = min(ymin, Y(iy+2*NPTS))
               ENDIF
            ENDIF
         ENDDO

 100     CONTINUE

         ies = ies + rgnenr(idset)

         IF ( idset .NE. dgndst() ) THEN
            ies = ies + 1
            Y(ies) = NO
            Y(ies+NPTS) = NO
            Y(ies+2*NPTS) = NO
         ENDIF

      ENDDO

      IF ( ixopt .EQ. 1 .OR. ixopt .EQ. 2 ) THEN
         CMD(NCMD+1) = 'LA X Energy (keV)'
      ELSEIF ( ixopt .EQ. 3 ) THEN
         CMD(NCMD+1) = 'LA X Wavelength (Angstrom)'
      ENDIF
      CMD(NCMD+2) = 'LA Y Effective Area (cm'//CHAR(92)//'u2'//CHAR(92)
     &              //'d)'
      CMD(NCMD+3) = 'LA T Total efficiency'
      CMD(NCMD+4) = 'LOG X'
      CMD(NCMD+5) = 'LOG Y'
      CMD(NCMD+6) = 'ERR OFF 1'
      NCMD = NCMD + 6
      IERY(1) = 1
      IERY(2) = 0
      DO idset = 1, dgndst()
         WRITE(cmd(ncmd+1),'(''LINE STEP '', i3)') idset
         WRITE(cmd(ncmd+2),'(''LSTYLE '', i3, '' ON '', i3)') idset, 
     &                                                        idset
         WRITE(cmd(ncmd+3),'(''COLOR '', i3, '' ON '', i3)') idset, 
     &                                                       idset
         ncmd = ncmd + 3
      ENDDO
      WRITE(cmd(ncmd+1),*) 'R Y ', ymin
      ncmd = ncmd + 1
      NVEC = 2

      RETURN
      END
